#ifndef _SAUCER_VECTOR_H_INCLUDED_
#define _SAUCER_VECTOR_H_INCLUDED_

typedef struct {
  double x;
  double y;
  double z;
} vector_t;

vector_t *vector_set(vector_t *vd, double x, double y, double z);
vector_t *vector_zero(vector_t *vd);
vector_t *vector_rand(vector_t *vd);
vector_t *vector_copy(vector_t *vd, vector_t *v0);
vector_t *vector_add(vector_t *vd, vector_t *v0, vector_t *v1);
vector_t *vector_sub(vector_t *vd, vector_t *v0, vector_t *v1);
vector_t *vector_mul(vector_t *vd, vector_t *v0, double r);
vector_t *vector_div(vector_t *vd, vector_t *v0, double r);
vector_t *vector_normalize(vector_t *vd, double r);

double vector_square(vector_t *vd);
double vector_length(vector_t *vd);

vector_t *vector_rotate_x(vector_t *vd, vector_t *v0, double angle);
vector_t *vector_rotate_y(vector_t *vd, vector_t *v0, double angle);
vector_t *vector_rotate_z(vector_t *vd, vector_t *v0, double angle);
vector_t *vector_normalize_angle_positive(vector_t *angle);
vector_t *vector_normalize_angle_sym(vector_t *angle);
vector_t *vector_calc_angle(vector_t *angle, vector_t *v0, vector_t *updir);

#endif
